#!/bin/bash
# 2004 Timo Latvala <timo.latvala@hut.fi>
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

args=$#;

if [ $args -ne "3" ] 
    then
    echo "Wrong number of arguments!";
    echo "Usage: runtest formulafileprefix k size";
    exit -1;
fi

#for all formula files with the given prefix
for formula in `ls $1*.txt`
do 
#uncomment this line if you want to regenerate the formulas 
# ./prefixToinfix.pl -o past-$formula $formula;
  a=0;
#for all formulas in the given file  
  while read line
    do
    let "a+=1";
# uncomment the line below to enable generation of random formulae 
#   ./randomKripke.pl -k $3 -l 3 -p 6  -o model-$a-$formula;
    LIMIT=$2;
    for ((i=1; i <= LIMIT ; i++)) 
      do
#set up testing using the default NuSMV encoding      
      echo "set input_file model-$a-$formula;" > bmcnusmv.commands;
      echo "go_bmc;" >> bmcnusmv.commands;
      echo "check_ltlspec_bmc_onepb -e dfl -p '"${line:8}"' -k $i" >> bmcnusmv.commands;
      echo "quit;">> bmcnusmv.commands;
#run the test
      ../../NuSMV/nusmv/NuSMV -v 0 -int < bmcnusmv.commands 2>> logNuSMV >> logNuSMVbig;
#set up testing using the new encoding
      echo "set input_file model-$a-$formula;" > bmctimo.commands;
      echo "go_bmc;" >> bmctimo.commands;
      echo "check_ltlspec_bmc_onepb -e new -p '"${line:8}"' -k $i" >> bmctimo.commands;
      echo "quit;">> bmctimo.commands;
#run the test
      ../../NuSMV/nusmv/NuSMV -v 0 -int < bmctimo.commands 2>> logTimo >> logTimobig;
    done
  done <past-$formula
  cat logTimo > logTimo-$formula;
  cat logNuSMV > logNuSMV-$formula;
  rm logTimo;
  rm logNuSMV;
done
